var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  useA11yModal: () => useA11yModal
});
var import_react = __toModule(require("react"));
var import_react_dom = __toModule(require("react-dom"));
const nativeInert = Element.prototype.hasOwnProperty("inert");
if (!nativeInert) {
  require("wicg-inert");
}
const TYPE = "a11y-modal-portal";
const useA11yModal = ({
  id,
  isOpen,
  autoFocus = true,
  onClickOutside = () => {
  },
  onEscapeKeyPress = () => {
  }
}) => {
  const labelId = `${id}_label`;
  const portalId = `${id}_portal`;
  const portalRef = import_react.default.useRef(null);
  const [, forceUpdate] = import_react.default.useState({});
  import_react.default.useEffect(() => {
    if (!isOpen) {
      return;
    }
    const portalNode = portalRef.current = document.createElement(TYPE);
    portalNode.setAttribute("id", portalId);
    portalNode.setAttribute("role", "region");
    document.body.appendChild(portalNode);
    forceUpdate({});
    return () => {
      portalRef.current = null;
      document.body.removeChild(portalNode);
      forceUpdate({});
    };
  }, [id, isOpen]);
  import_react.default.useEffect(() => {
    if (!isOpen) {
      return;
    }
    const activeElement = document.activeElement;
    if (autoFocus) {
      window.requestAnimationFrame(() => {
        const focusElement = document.querySelector(`
            #${id} input:not([tabindex="-1"]):not([disabled]):not([readonly]), 
            #${id} textarea:not([tabindex="-1"]):not([disabled]):not([readonly]), 
            #${id} select:not([tabindex="-1"]):not([disabled]):not([readonly]), 
            #${id} button:not([tabindex="-1"]):not([disabled]):not([readonly]), 
            #${id} iframe:not([tabindex="-1"]):not([disabled]):not([readonly]),
            #${id} object:not([tabindex="-1"]):not([disabled]):not([readonly]),
            #${id} embed:not([tabindex="-1"]):not([disabled]):not([readonly])
            #${id} [tabindex]:not([tabindex="-1"]):not([disabled]):not([readonly])
            #${id} [href]:not([tabindex="-1"]):not([disabled]):not([readonly]), 
            #${id} [contenteditable]:not([tabindex="-1"]):not([disabled]):not([readonly]),
            #${id} [autofocus]:not([tabindex="-1"]):not([disabled]):not([readonly])
          `) || document.querySelector(`#${id}`);
        if (focusElement) {
          focusElement.focus();
        }
      });
    }
    const overflow = window.getComputedStyle(document.body).overflow;
    document.body.style.overflow = "hidden";
    const clickOutsideListener = (e) => {
      if (document.querySelector(`#${portalId}`) && document.querySelector(`#${portalId}`).getAttribute("inert") !== "" && document.querySelector(`#${id}`) && !document.querySelector(`#${id}`).contains(e.target)) {
        onClickOutside(e);
      }
    };
    const escapeKeyPressListener = (e) => {
      if (document.querySelector(`#${portalId}`) && document.querySelector(`#${portalId}`).getAttribute("inert") !== "" && e.key === "Escape") {
        onEscapeKeyPress(e);
      }
    };
    document.body.addEventListener("mousedown", clickOutsideListener);
    document.body.addEventListener("touchstart", clickOutsideListener);
    document.body.addEventListener("keydown", escapeKeyPressListener);
    const hiddenNodes = Array.from(document.querySelectorAll(`body > *`)).map((rootNode) => {
      if (rootNode.tagName === TYPE.toUpperCase() && rootNode.getAttribute("id") === portalId) {
        return null;
      }
      return {
        node: rootNode,
        inert: rootNode.getAttribute("inert"),
        hidden: nativeInert ? rootNode.getAttribute("aria-hidden") : null
      };
    }).filter((hiddenNode) => hiddenNode !== null);
    hiddenNodes.forEach((hiddenNode) => {
      hiddenNode.node.setAttribute("inert", "");
      if (nativeInert) {
        hiddenNode.node.setAttribute("aria-hidden", "true");
      }
    });
    return () => {
      hiddenNodes.forEach((hiddenNode) => {
        hiddenNode.inert === null ? hiddenNode.node.removeAttribute("inert") : hiddenNode.node.setAttribute("inert", hiddenNode.inert);
        if (nativeInert) {
          hiddenNode.hidden === null ? hiddenNode.node.removeAttribute("aria-hidden") : hiddenNode.node.setAttribute("aria-hidden", hiddenNode.hidden);
        }
      });
      document.body.removeEventListener("mousedown", clickOutsideListener);
      document.body.removeEventListener("touchstart", clickOutsideListener);
      document.body.removeEventListener("keydown", escapeKeyPressListener);
      document.body.style.overflow = overflow;
      window.requestAnimationFrame(() => {
        if (activeElement) {
          activeElement.focus();
        }
      });
    };
  }, [id, isOpen, autoFocus]);
  return import_react.default.useMemo(() => ({
    createPortal: (children) => portalRef.current ? import_react_dom.default.createPortal(children, portalRef.current) : null,
    modalProps: {
      id,
      role: "dialog",
      tabIndex: -1,
      "aria-labelledby": labelId,
      "aria-modal": true
    },
    titleProps: {
      id: labelId,
      role: "heading",
      tabIndex: -1
    }
  }), [id]);
};
//# sourceMappingURL=index.js.map
